#include "StdAfx.h"
#include "MMLfile.h"

//==============================================================
//		RXgN^
//--------------------------------------------------------------
//	
//		const	char*	strFileName		t@C
//	Ԓl
//				
//==============================================================
MMLfile::MMLfile(const char*	strFileName):
	offset_Ei(0),
	offset_Ev(0),
	offset_En(0),
	offset_Em(0),
	timebase(24),
	octave_reverse(false),
//	f_macro(false),
	p_macro(0),
	f_macro2(false),
	f_2to1(false)
	{
	//File open
	nowFile	= new FileInput();

	nowFile->fileopen(strFileName);
	ptcFiles.push_back(nowFile);

	iFiles = 0;
}

//==============================================================
//		fXgN^
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
MMLfile::~MMLfile(void)
{

	//----------------------
	//Localϐ
	vector	<FileInput*>::iterator	itFiles;

	//----------------------
	//Delete Class
	itFiles = ptcFiles.begin();
	while(itFiles != ptcFiles.end()){
		(*itFiles)->close();
		delete *itFiles;
		itFiles++;
	}
	ptcFiles.clear();

}

//==============================================================
//			݃RpC̃t@C[EOF]`FbN
//--------------------------------------------------------------
//	
//			
//	Ԓl
//			bool		true	[EOF]o
//						false	܂I肶ȂB
//==============================================================
bool	MMLfile::eof(void)
{
	return( nowFile->eof() );
}

//==============================================================
//			MMLt@C̏I`FbN
//--------------------------------------------------------------
//	
//			
//	Ԓl
//			bool		true	t@C[EOF]o
//						false	܂I肶ȂB
//==============================================================
bool	MMLfile::eom(void)
{
	if(( iFiles == 0 ) && ( eof() )){
		return(true);
	}
	return(false);
}

//==============================================================
//		CN[ht@C
//--------------------------------------------------------------
//	
//			
//	Ԓl
//			
//	
//			݂̃t@C|C^ɏĂt@CCN[h
//==============================================================
void	MMLfile::include()
{
	//----------------------
	//Localϐ
	vector	<FileInput*>::iterator	itFiles;
	string	_name = GetString();

	//----------------------
	//t@CJĂȂ`FbN
	itFiles = ptcFiles.begin();
	while(itFiles != ptcFiles.end()){
		if( *(*itFiles)->GetFilename() == _name ){
			Err(L"ɓt@C#includeŊJĂ܂B");
		}
		itFiles++;
	}

	//----------------------
	//File open
	nowFile	= new FileInput();

	nowFile->fileopen(_name.c_str());
	ptcFiles.push_back(nowFile);

	iFiles++; 
}

//==============================================================
//		}N̐ݒ
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//	
//			݂̃t@C|C^ɏĂ}N`B
//==============================================================
void	MMLfile::SetMacro(void)
{
	char	cData;
	string	macro_name		="";
	string	macro_contents	="";

	//------------------
	//}N̎擾
	while((cData = cRead()) > 0x20){
		if(cData == '{'){
			break;
		}
		macro_name += cData;
	};
	Back();

	//------------------
	//}N̏d`FbN
	if(ptcMac.count(macro_name) != 0){
		Err(L"ɂ̃}N݂͑Ă܂B");
	}

	//------------------
	//}Ne̎擾
	while(cRead() != '{'){
		if(eof()){
			Err(L"Jn{܂B");
		}
	}

	while('}' != (cData = cRead())){
		if(eof()){
			Err(L"I}܂B");
		}
		macro_contents += cData;
	}
	macro_contents += " ";

	//------------------
	//}Ne̐ݒ
	ptcMac[macro_name] = macro_contents;
}

//==============================================================
//		}ŇĂяo
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//	
//			݂̃t@C|C^ɏĂ}NĂяo
//==============================================================
void	MMLfile::CallMacro(void)
{
	char		cData;
	int			i		= 0;
	string		_name	= "";

	//------------------
	//}N̎擾
	while((cData = cRead()) > 0x20){
		_name += cData;
	};
	Back();

	//------------------
	//}N̑݃`FbN
	if(ptcMac.count(_name) == 0){
		Err(L"̃}N݂͑Ă܂B");
	}

	//------------------
	//}N̏d`FbN
	while(i < p_macro){
		if(s_macro[i].name == _name){
			Err(L"}Nœ}NĂяoĂ܂B");
		}
		i++;
	}

	//------------------
	//lXgۑ
	if(p_macro > 0){
		s_macro[p_macro-1].name = nowMacro.name;
		s_macro[p_macro-1].line = nowMacro.line;
	}

	nowMacro.name = _name;
	nowMacro.line = 0;

	s_macro.push_back(nowMacro);
	p_macro++;

}

//==============================================================
//			݃RpC̃t@C|C^̎擾
//--------------------------------------------------------------
//	
//			
//	Ԓl
//			int		݂̃t@C|C^
//==============================================================
int		MMLfile::tellg(void)
{
	int	i;

	if(p_macro > 0){
		i = nowMacro.line;
	} else {
		i = nowFile->tellg();
	}

	return(i);
}

//==============================================================
//			݃RpC̃t@C|C^ΓIɈړ
//--------------------------------------------------------------
//	
//			long	iSize	ړl
//	Ԓl
//			
//==============================================================
void	MMLfile::StreamPointerMove(long iSize)
{
	if(p_macro > 0){
		nowMacro.line = iSize;
	} else {
		nowFile->StreamPointerMove(iSize);
	}
}

//==============================================================
//			݃RpC̃t@C|C^߂
//--------------------------------------------------------------
//	
//			
//	Ԓl
//			
//==============================================================
void	MMLfile::Back_one(void)
{
	if(f_macro2 == true){
		f_macro2 = false;
		if(p_macro > 0){
			s_macro[p_macro-1].name = nowMacro.name;
			s_macro[p_macro-1].line = nowMacro.line;
		}
		p_macro++;
		nowMacro.name = s_macro[p_macro-1].name;
		nowMacro.line = s_macro[p_macro-1].line;
		nowMacro.line--;
	} else {
		if(p_macro > 0){
			nowMacro.line--;
		} else {
			nowFile->Back();
		}
	}
}
void	MMLfile::Back(void)
{
	if(f_2to1==true){
		Back_one();
		Back_one();
	} else {
		Back_one();
	}

}

//==============================================================
//			PByteǂݍ
//--------------------------------------------------------------
//	
//			
//	Ԓl
//			char	ǂݍݒl
//==============================================================
char	MMLfile::read_char(void)
{
	char	cData;

	if(f_macro2 == true){
		f_macro2	= false;
		s_macro.pop_back();
	}
	if(p_macro > 0){
		cData = ptcMac[nowMacro.name][nowMacro.line];
		nowMacro.line++;
		if(ptcMac[nowMacro.name].size() == nowMacro.line){
			s_macro[p_macro-1].name = nowMacro.name;
			s_macro[p_macro-1].line = nowMacro.line;
			p_macro--;
			f_macro2	= true;
			if(p_macro > 0){
				nowMacro.name = s_macro[p_macro-1].name;
				nowMacro.line = s_macro[p_macro-1].line;
			}
		}
	} else {
		cData		= nowFile->cRead();
	}

	return(cData);

}

//==============================================================
//			PByteǂݍ
//--------------------------------------------------------------
//	
//			
//	Ԓl
//			char	ǂݍݒl
//==============================================================
char	MMLfile::cRead(void)
{
	unsigned	char	cData = read_char();
	unsigned	char	cDataMSB;

	switch(cData){
		case(0x81):
			cDataMSB = read_char();
			f_2to1 = true;
			switch(cDataMSB){
				case(0x69):
					cData = '(';
					break;
				case(0x6A):
					cData = ')';
					break;
				case(0x6F):
					cData = '{';
					break;
				case(0x70):
					cData = '}';
					break;
				case(0x7B):
					cData = '+';
					break;
				case(0x7C):
					cData = '-';
					break;
				case(0x94):	//
					cData = '#';
					break;
				case(0xF3):	//
					cData = '-';
					break;
				default:
					f_2to1 = false;
					Back();
					break;
			}
			break;

		case(0x82):
			cDataMSB = read_char();
			f_2to1 = true;
			switch(cDataMSB){
				case(0x4F):
					cData = '0';
					break;
				case(0x50):
					cData = '1';
					break;
				case(0x51):
					cData = '2';
					break;
				case(0x52):
					cData = '3';
					break;
				case(0x53):
					cData = '4';
					break;
				case(0x54):
					cData = '5';
					break;
				case(0x55):
					cData = '6';
					break;
				case(0x56):
					cData = '7';
					break;
				case(0x57):
					cData = '8';
					break;
				case(0x58):
					cData = '9';
					break;
				default:
					f_2to1 = false;
					Back();
					break;
			}
			break;

		default:
			f_2to1 = false;
			break;
	}

	return(cData);
}

//==============================================================
//			PByteǂݍ݁i`FbNtj
//--------------------------------------------------------------
//	
//			
//	Ԓl
//			char	ǂݍݒl
//	
//		P̓ǂݍ݁B
//		AAȉ̋Lqꍇ́A΂B
//			E0x20ȉ̃LN^[R[h
//			ERg
//		܂ACN[ht@C[EOF]oAÕt@Cɖ߂
//==============================================================
char	MMLfile::GetChar(void)		//1Byte̓ǂݍ
{
	unsigned	char	cData;

	do{
		cData = cRead();

		//[EOM]H
		if( eom() )
		{
			return(0);

		//[EOF]H
		} else if( eof() ){
			nowFile->close();
			delete	nowFile;
			ptcFiles.pop_back();
			nowFile = ptcFiles.back();
			iFiles--;
			//continue

		//0x20ȉ̐R[h
		} else if(cData <= 0x20){
			//continue

		//AZu^CṽRgH
		} else if(cData == ';'){
			do{
				cData = cRead();		//̃oCgǂݍ
			} while((cData != 0x0A)||eof());
		
		//b^CṽRgH
		} else 	if(cData == '/'){
			cData = cRead();		//̃oCgǂݍ
			switch(cData){

				//PsRg
				case('/'):
					do{
						cData = cRead();		//̃oCgǂݍ
					}while((cData != 0x0A)||eof());
					break;

				//͈̓Rg
				case('*'):
					do{
						do{
							cData = cRead();		//̃oCgǂݍ
							if(eof()){
								Err(L"RgI[ */ ܂B");
							}
						}while(cData != '*');
						cData = cRead();
						Back();					//StreamPointerAdd(-1);
					} while(cData != '/');
							cRead();			//StreamPointerAdd(+1); B
					break;

				//ȊO
				default:
					Err(L"RgłH");
					break;
			}

		//[EOF]łARgłꍇB
		} else {
			break;		//while(1)  break;
		}

	}while(1);

	return(cData);
}

//==============================================================
//			ǂݍ
//--------------------------------------------------------------
//	
//			
//	Ԓl
//			string	ǂݍ񂾕
//	
//			MML""ň͂܂ꂽ擾B
//==============================================================
string	MMLfile::GetString(void)
{
	char	cData;
	
	string	_str;
	while(cRead() != '"'){
		if(eof()){
			Err(L"Jn\"܂B");
		}
	}

	while('"' != (cData = cRead())){
		if(eof()){
			Err(L"I\"܂B");
		}
		_str += cData;
	}
	return(_str);
}

//==============================================================
//			lǂݍ
//--------------------------------------------------------------
//	
//			
//	Ԓl
//			int		ǂݍ񂾐l
//	
//			MML()ň͂܂ꂽ擾B
//==============================================================
int	MMLfile::GetNum(void)
{
	char	cData;
	int		iResult;

	while(cRead() != '('){
		if(eof()){
			Err(L"lJn(܂B");
		}
	}

	iResult = GetInt();

	while(')' != (cData = cRead())){
		if(eof()){
			Err(L"lI)܂B");
		}
	}
	return(iResult);
}

//==============================================================
//			lǂݍ
//--------------------------------------------------------------
//	
//			
//	Ԓl
//			int		ǂݍ񂾐l
//==============================================================
int		MMLfile::GetInt(void)
{
				bool	neg = false;			//
				int		iResult = 0;			//Z
	unsigned	char	cData = GetChar();

	//16i
	if(cData == '$'){
		cData = cRead();
		if(cData == '+'){
			neg = false;
			cData	 = cRead();
		}
		if(cData == '-'){
			neg = true;
			cData	 = cRead();
		}
		while(((cData >= '0') && (cData <= '9')) || ((cData >= 'a') && (cData <= 'f')) || ((cData >= 'A') && (cData <= 'F'))){
			iResult <<= 4;
			if((cData >= '0') && (cData <= '9')){
				iResult += (unsigned int)cData - 0x30;
			} else if((cData >= 'A') && (cData <= 'F')){
				iResult += (unsigned int)cData - 0x41 + 10;
			} else if((cData >= 'a') && (cData <= 'f')){
				iResult += (unsigned int)cData - 0x61 + 10;
			}
			cData	 = cRead();
		}

	//Qi
	} else if(cData == '%'){
		cData = cRead();
		if(cData == '-'){
			neg = true;
			cData	 = cRead();
		}
		while((cData >= '0') && (cData <= '1')){
			iResult <<= 1;
			iResult += (unsigned int)cData - 0x30;
			cData	 = cRead();
		}

	//10i
	} else if(((cData >= '0') && (cData <= '9')) || (cData == '-') || (cData == '+')){
		if(cData == '+'){
			neg = false;
			cData	 = cRead();
		}
		if(cData == '-'){
			neg = true;
			cData	 = cRead();
		}
		while((cData >= '0') && (cData <= '9')){
			iResult *= 10;
			iResult += (unsigned int)cData - 0x30;
			cData	 = cRead();
		}

	} else {
			Err(L"lȊOw肳܂B");
	}

	//|C^P߂
	Back();							//	StreamPointerAdd(-1);

	//
	if(neg == true){
		iResult = -iResult;
	}

	return(iResult);
}

//==============================================================
//			ǂݍ
//--------------------------------------------------------------
//	
//			int		LڂȂꍇ̉[tick]
//	Ԓl
//			int		[tick]
//	
//		ǂݍށit_tj
//==============================================================
int	MMLfile::readLength(unsigned int DefaultLength){

	char	cData;				//ǂݍݗp
	int		iLength;			// [tick]
	int		iDot;				//t_vZp [tick]
	int		iMod;
	int		i;

	//ǂݍ
	cData = GetChar();

	//Length
	if(((cData >= '0') && (cData <= '9')) || (cData == '.')){
		//|C^P߂
		Back();							//StreamPointerAdd(-1);
		if((cData >= '0') && (cData <= '9')){
			i = GetInt();
			iLength = (timebase * 4) / i;
			iMod	= (timebase * 4) % i;
			if(iMod != 0){
				Warning(L"̌vZŊ؂܂łB_͐؎̂Ă܂B");
			}
		} else {
			iLength = DefaultLength;
		}

		iDot	= iLength;
		//t_
		while((cData = cRead()) == '.'){
			iMod = (iDot & 0x01);
			iDot >>= 1;
			if(iMod != 0){
				Warning(L"t_̌vZŊ؂܂łB_͐؎̂Ă܂B");
			}
			iLength += iDot;
		};
		Back();							//StreamPointerAdd(-1);



	//Tick
	} else if (cData == '%'){
		iLength = GetInt();

	} else {
		iLength = -1;
	}

	return(iLength);
}

//==============================================================
//			ǂݍ
//--------------------------------------------------------------
//	
//			int		LڂȂꍇ̉[tick]
//	Ԓl
//			int		ǂݍ񂾐l
//					ĂȂꍇ́A -1 ԂB
//==============================================================
int		MMLfile::GetLength(unsigned int DefaultLength)	//
{
	char	cData;				//ǂݍݗp
	int		iLength;			// [tick]
	int		iCalc;
	bool	add;

	//ǂݍ
	iLength = readLength(DefaultLength);
	if(iLength == -1){
		return(iLength);
	}

	//̉Z
	cData = cRead();
	while((cData == '+') || (cData == '-')){
		//ŌvZ镄̃`FbN
		if(cData == '+'){
			add = true;
		} else {
			add = false;
		}
		iCalc = readLength(DefaultLength);
		if(iCalc == -1){
			Err(L"̉ZlɐlȊOw肳Ă܂B");
		}
		if(add == true){
			iLength += iCalc;
		} else {
			iLength -= iCalc;
		}
		cData = cRead();
	};
	Back();							//StreamPointerAdd(-1);

	if((iLength < 1) || (iLength > 255)){
		Err(L"́A%1i96j`%255i1+1+2+8j̊ԂŎw肵ĉB255[tick]𒴂ꍇ̓^C`&', `^'gĉB");
	}

	return(iLength);
}

//==============================================================
//		R}hID̎擾
//--------------------------------------------------------------
//	
//		Command_Info*			_command
//		unsigned		int		_size
//	Ԓl
//		int			R}hR[h@i-1unknown commandj
//==============================================================
int	MMLfile::GetCommandID(const Command_Info _command[], unsigned int _size)
{
	unsigned	int		ptCommand	= tellg();	//݂̃t@C|C^ێĂB
	unsigned	int		i			= 0;		//p
	unsigned	int		j;						//`FbNp

	//R}h̃`FbN
	while(i < _size){
		StreamPointerMove(ptCommand);
		j = 0;
		do{
			if(_command[i].str[j] == 0){
				return(_command[i].id);
			}
		} while(cRead() == _command[i].str[j++]);
		i++;
	}
	return(-1);
}

//==============================================================
//		G[
//--------------------------------------------------------------
//	
//		const	wchar_t	msg[]	G[bZ[W
//	Ԓl
//				
//==============================================================
void	MMLfile::Err(const wchar_t msg[])
{
	//݂̃t@CƁAs\
	cout << "[ ERROR ] " << nowFile->GetFilename()->c_str() << " (Line = " << nowFile->GetLine() << ") : ";

	//G[e\
	wcout << msg << endl;

	//ُI
	exit(-1);
}

//==============================================================
//		[jO
//--------------------------------------------------------------
//	
//		const	wchar_t	msg[]	[jObZ[W
//	Ԓl
//				
//==============================================================
void	MMLfile::Warning(const wchar_t msg[])
{
	//݂̃t@CƁAs\
	cout << "[WARNING] " << nowFile->GetFilename()->c_str() << " (Line = " << nowFile->GetLine() << ") : ";

	//[jOe\
	wcout << msg << endl;
}
